//pwm.h
#include <inarm.h>
#include <stdio.h>
#include <stdlib.h>
#include "board.h"

CSP_PWM4C_T * const PWM4C     = ((CSP_PWM4C_T *)   PWM_BASE_ADDRESS);


void Pwm0Enable(void) {

  // PWM Enable Channel 0
  PWM4C->CR |= PWMEN0;
}

void Pwm0Disable(void) {

  // PWM Disable Channel 0
  PWM4C->CR |= PWMDIS0;
}

void Pwm1Enable(void) {

  // PWM Enable Channel 1
  PWM4C->CR |= PWMEN1;
}

void Pwm1Disable(void) {

  // PWM Disable Channel 1
  PWM4C->CR |= PWMDIS1;
}

void Pwm2Enable(void) {

  // PWM Enable Channel 2
  PWM4C->CR |= PWMEN2;
}

void Pwm2Disable(void) {

  // PWM Disable Channel 2
  PWM4C->CR |= PWMDIS2;
}

void Pwm3Enable(void) {

  // PWM Enable Channel 3
  PWM4C->CR |= PWMEN3;
}

void Pwm3Disable(void) {

  // PWM Disable Channel 3
  PWM4C->CR |= PWMDIS3;
}


void InitPwm0(void) {

  // Disable PWM
  PWM4C->ECR = PWMEN;

  // PWM Enable Channel 0
  // PWM4C->CR = PWMEN0;

  // Divider for chanel 0
  PWM4C->MR |= PRESCAL0(15);

  // Set delay for PWM chanel 0
  PWM4C->CHANNEL[0].DLY = 0xFF;

  // Set delay for PWM chanel 0
  PWM4C->CHANNEL[0].PUL = 0xFF;

  // Disable PWM
  // PWM4C->DCR = PWMEN;

}

void InitPwm1(void) {

  // Disable PWM
  PWM4C->ECR = PWMEN;

  // PWM Enable Channel 1
  // PWM4C->CR = PWMEN1;

  // Divider for chanel 1
  PWM4C->MR |= PRESCAL1(10);

  // Set delay for PWM chanel 1
  PWM4C->CHANNEL[1].DLY = 5;

  // Set delay for PWM chanel 1
  PWM4C->CHANNEL[1].PUL = 5;

  // Disable PWM
  // PWM4C->DCR = PWMEN;

}

void InitPwm2(void) {

  // Disable PWM
  PWM4C->ECR = PWMEN;

  // PWM Enable Channel 2
  // PWM4C->CR = PWMEN2;

  // Divider for chanel 2
  PWM4C->MR |= PRESCAL2(10);

  // Set delay for PWM chanel 2
  PWM4C->CHANNEL[2].DLY = 5;

  // Set delay for PWM chanel 2
  PWM4C->CHANNEL[2].PUL = 5;

  // Disable PWM
  // PWM4C->DCR = PWMEN;

}

void InitPwm3(void) {

  // Disable PWM
  PWM4C->ECR = PWMEN;

  // PWM Enable Channel 3
  // PWM4C->CR = PWMEN3;

  // Divider for chanel 3
  PWM4C->MR |= PRESCAL3(10);

  // Set delay for PWM chanel 3
  PWM4C->CHANNEL[3].DLY = 5;

  // Set delay for PWM chanel 3
  PWM4C->CHANNEL[3].PUL = 5;

  // Disable PWM
  // PWM4C->DCR = PWMEN;

}

